%{
  open Arith_type
%}

%token <int> INT
%token PLUS MINUS TIMES DIV
%token LPAREN RPAREN
%token EOL
%left PLUS MINUS        /* lowest precedence */
%left TIMES DIV         /* medium precedence */
%nonassoc UMINUS        /* highest precedence */
%start main             /* the entry point */
%type <Arith_type.arith> main
%%
main:
  expr EOL                { $1 }
  ;
  expr:
    INT                     { Int $1 }
  | LPAREN expr RPAREN      { $2 }
  | expr PLUS expr          { Op(Plus,$1,$3) }
  | expr MINUS expr         { Op(Moins,$1,$3) }
  | expr TIMES expr         { Op(Mult,$1,$3) }
  | MINUS expr %prec UMINUS { Minus $2 }
  ;
